#!/bin/sh


######################################################
#                Mkdir
######################################################
#declare -a StrainLevel=($(seq 0.0 0.01 0.10) $(seq 0.20 0.10 1.00) 2.00 2.50 3.00 3.50 4.00)
declare -a StrainLevel=($(seq 0.00 0.10 4.00))

#declare -a StrainLevel=(0.01)

declare -a StrainType=(uni110/ uni111/)


for uni in ${StrainType[@]}; do
  mkdir ${uni}
  for strain in ${StrainLevel[@]}; do
    mkdir ${uni}${strain}%
    cp -r {run.abi,job.sh} ${uni}${strain}%
    python set_input.py ${uni}${strain}%
  done 
done

for uni in ${StrainType[@]}; do
for strain in ${StrainLevel[@]}; do
  cd /scratch/ucl/elen/nroisin/StrainedSi/Relaxation/${uni}${strain}%
  sbatch job.sh
done 
done
