#!/usr/bin/python
import sys
import numpy as np
from Straintensor import * 
def replace_structure(file_path, rprim, xred):
  f=open(file_path,"r")
  lines=f.readlines()
 
  i=0
  for line in lines: 
      if line[:6]==" rprim":
          #lines[i]=  "rprim\n "

          lines[i+1]="      "+str(rprim[0][0])+" "+str(rprim[0][1])+" "+str(rprim[0][2])+" \n"
          lines[i+2]="      "+str(rprim[1][0])+" "+str(rprim[1][1])+" "+str(rprim[1][2])+" \n"
          lines[i+3]="      "+str(rprim[2][0])+" "+str(rprim[2][1])+" "+str(rprim[2][2])+" \n"
      if line[:5]==" xred":
          lines[i+1]="      "+str(xred[0][0])+" "+str(xred[0][1])+" "+str(xred[0][2])+"\n"
          lines[i+2]="      "+str(xred[1][0])+" "+str(xred[1][1])+" "+str(xred[1][2])+"\n"
  
          
      
      i=i+1
  f.close()
  
  f=open(file_path,"w")
  f.writelines(lines)
  f.close()
  
  return 0

def replace(filepath,line_name,parameter,j=0):
  f=open(filepath,"r")
  lines=f.readlines()
  f.close()  
  i=0
  for line in lines:
    if line[:len(line_name)]==line_name:
      lines[i+j]=parameter
      
    i=i+1
    

  
  f=open(filepath,"w")
  f.writelines(lines)
  f.close()  
  
  return 0
  
poisson=True
iomode=3
optcell=0
ionmov=2
ecut=20
ngkpt=[18,18,18]  


for filepath in sys.argv[1:]:
  splt=filepath.split("/")
  epsilon=straintensor_scalar(direction=splt[0][:3],cristal_plane=splt[0][3:6],eps=np.round(float(splt[1][:-1])/100,6),C11=16.577,C12=6.393,C44=7.962,poisson=poisson)
  rprim=np.array([[0,  0.5,  0.5],   
                  [0.5,  0.0,  0.5],
                  [0.5,  0.5,  0.0]]).dot(np.eye(3)+epsilon[:,:])
  xred=[[0.0 , 0.0 , 0.0],
        [0.25, 0.25, 0.25]]
  replace_structure(filepath+"/run.abi", rprim, xred)    
  
  replace(filepath+"/run.abi"," acell"," acell 3*10.33491364 \n",j=0)
  replace(filepath+"/run.abi"," ecut"," ecut 20\n",j=0) 
  replace(filepath+"/run.abi"," ngkpt"," ngkpt 18 18 18\n",j=0)                       
  replace(filepath+"/run.abi"," ionmov"," ionmov 2\n",j=0) 
  replace(filepath+"/run.abi"," optcell"," optcell 0\n",j=0)   
  
  replace(filepath+"/job.sh","#SBATCH --job-name=","#SBATCH --job-name=Struc_"+splt[0]+"_"+splt[1]+"\n",j=0)   
  replace(filepath+"/job.sh","#SBATCH --time=","#SBATCH --time=00:45:00\n",j=0)   
  replace(filepath+"/job.sh","#SBATCH --tasks-per-node=","#SBATCH --tasks-per-node=2\n",j=0)   
  replace(filepath+"/job.sh","tasks_per_node=","tasks_per_node=2\n",j=0)   
  replace(filepath+"/job.sh","#SBATCH --mem-per-cpu=","#SBATCH --mem-per-cpu=500\n",j=0)   

  print("filepath :",filepath+"/run.abi"," - direction :",splt[0][:-3]," - cristal_plane :",splt[0][-3:],"- Poisson",str(poisson),"- eps :",np.round(float(splt[1][:-1])/100,6))
  
  
